require 'display_triangle.rb'
require 'pattern_canvas.rb'

# -------------------------------------------------------
# --- demo display class
# -------------------------------------------------------

class TriangleMargeDemo < MYGLWindowViewTriangle

  def initialize(width, height, title)
    @canvas = PatternStorage.new
    @tri1 = PTriangle.new
    @tri2 = PTriangle.new
    @tri3 = PTriangle.new
    @tick_count = 0
    @outline = false
    #
    super
  end

  def mouse_down(e)
    super
    if e.Button.to_s == 'Right' then
      @outline = !@outline
    end
    if e.Button.to_s == 'Middle' then
      p1 = @tri1.get_point(0)
      p2 = @tri1.get_point(1)
      p3 = @tri1.get_point(2)
      p4 = @tri2.get_point(0)
      p5 = @tri2.get_point(1)
      p6 = @tri2.get_point(2)
      printf("  p1 = PPoint.new( %1.3f, %1.3f, %1.3f)\n", p1.x, p1.y, p1.z)
      printf("  p2 = PPoint.new( %1.3f, %1.3f, %1.3f)\n", p2.x, p2.y, p2.z)
      printf("  p3 = PPoint.new( %1.3f, %1.3f, %1.3f)\n", p3.x, p3.y, p3.z)
      printf("  p4 = PPoint.new( %1.3f, %1.3f, %1.3f)\n", p4.x, p4.y, p4.z)
      printf("  p5 = PPoint.new( %1.3f, %1.3f, %1.3f)\n", p5.x, p5.y, p5.z)
      printf("  p6 = PPoint.new( %1.3f, %1.3f, %1.3f)\n", p6.x, p6.y, p6.z)
    end
  end

  def mouse_move
    super
#    return if @mouse_drag == false
#    mx = @window.mouse.x
#    my = @window.mouse.y
#    dx = (@mouse_pos_x - mx) / 2.0
#    dy = (@mouse_pos_y - my) / 2.0
#    if dx > 0 then
#      @tick_count += 1
#    end
#    if dx < 0 then
#      @tick_count -= 1
#    end
#    @mouse_pos_x = mx
#    @mouse_pos_y = my
  end

  def tick
    move_triangle
    @canvas.clear
    @canvas.add(@tri1)
    @canvas.add(@tri2)
    @canvas.add(@tri3)
    @canvas.drip_outline
    #
    clear_object()
    if @outline == true then
      @canvas.outline.each do |line|
        add_line(line)
      end
    else
      @canvas.object.each do |line|
        add_object(line)
      end
    end
    #
    @tick_count += 1
    refresh
  end

  def move_triangle
    p1 = PPoint.new(-1.0, -0.8, 0)
    p2 = PPoint.new( 0.2,  0.7, 0)
    p3 = PPoint.new( 0.9, -0.9, 0)
    p4 = PPoint.new( 0.8,  0.5, 0)
    p5 = PPoint.new( 0.2, -0.7, 0)
    p6 = PPoint.new(-0.7,  0.4, 0)
    p7 = PPoint.new( 0.3, -0.2, 0)
    p8 = PPoint.new( 0.3,  0.1, 0)
    p9 = PPoint.new(-0.1,  0.2, 0)
    @tri1.set_point(0, p1)
    @tri1.set_point(1, p2)
    @tri1.set_point(2, p3)
    @tri1.normalize
    @tri2.set_point(0, p4)
    @tri2.set_point(1, p5)
    @tri2.set_point(2, p6)
    @tri2.normalize
    @tri3.set_point(0, p7)
    @tri3.set_point(1, p8)
    @tri3.set_point(2, p9)
    @tri3.normalize
    #
    r1 = 1.0 * @tick_count
    r2 = -1.7 * @tick_count
    r3 = 0.6 * @tick_count
    @tri1.get_point(0).rotate_z(r1)
    @tri1.get_point(1).rotate_z(r1)
    @tri1.get_point(2).rotate_z(r1)
    @tri2.get_point(0).rotate_z(r2)
    @tri2.get_point(1).rotate_z(r2)
    @tri2.get_point(2).rotate_z(r2)
    @tri3.get_point(0).rotate_z(r3)
    @tri3.get_point(1).rotate_z(r3)
    @tri3.get_point(2).rotate_z(r3)
    #
    m1 = 0.003 * @tick_count
    m2 = -0.00183 * @tick_count
    m3 = -0.0009 * @tick_count
    m4 = 0.0021 * @tick_count
    m5 = 0.0007 * @tick_count
    m6 = -0.0014 * @tick_count
    mv1 = PPoint.new( 1.0*Math.cos(m1), 0.5*Math.sin(m3), 0)
    mv2 = PPoint.new( 1.0*Math.cos(m2), 0.5*Math.sin(m4), 0)
    mv3 = PPoint.new( 1.0*Math.sin(m5), 0.5*Math.cos(m6), 0)
    @tri1.get_point(0).add(mv1)
    @tri1.get_point(1).add(mv1)
    @tri1.get_point(2).add(mv1)
    @tri2.get_point(0).add(mv2)
    @tri2.get_point(1).add(mv2)
    @tri2.get_point(2).add(mv2)
    @tri3.get_point(0).add(mv3)
    @tri3.get_point(1).add(mv3)
    @tri3.get_point(2).add(mv3)
  end

end



# -------------------------------------------------------
# --- boot & main
# -------------------------------------------------------

demo = TriangleMargeDemo.new(800, 600, "Triangle marge demo")
demo.running